#!/usr/bin/python
from sys import argv, stdin
import json
import jedi
filename = argv[1]
line = int(argv[2])
column = int(argv[3])-1
source = stdin.read()
script = jedi.Script(source, line, column, filename)
completions = script.complete()
output = []

for completion in completions:
	item = {}
	kind = completion.type
	name = completion.name
	item["string"] = name
#	fullname = completion.full_name
#	if not fullname:
#		fullname = ""
	description = completion.docstring(raw=False)
	newline = description.find("\n")
	if newline != -1:
		arrow = description.find("-> ", 0, newline)
		type = ""
		if arrow != -1:
			type = description[arrow+3:newline]
			if type == "integer": type = "int"
			elif type.startswith("list of"): type = "list"
			elif type == "number" or type == "bool" or type == "value" or type == "string" or type == "character" or type == "object" or type == "list" or type == "dictionary" or type == "int" or type == "float" or type == "long" or type == "module" or type == "tuple" or type == "module":
				pass
			else: type = ""
			if newline+2 <= len(description):
				description = description[newline+2:]
			else:
				description = ""
	#	if len(fullname) > len(name) and fullname.endswith(name):
	#		fullname = fullname[:-len(name)]
	#		while fullname.endswith("."):
	#			fullname = fullname[:-1]
	#		if len(fullname) > 0:
	#			library = "<strong>"+fullname+"</strong>"
	#			if len(description) > 0:
	#				library += " &mdash; "
	#			description = library+description
		if type:
			item["type"] = type
	if description:
#		description = description.replace("\n", "<br>")
		loc = 0
		close = False
		while True:
			code = description.find("``", loc)
			if code == -1: break
			loc += code+6
			if close:
				loc += 1
				tag = "</code>"
			else:
				tag = "<code>"
			description = description[0:code]+tag+description[code+2:]
			close = not close
		item["description"] = description
	if kind == "function" or kind == "class":
		try:
			insertion = ""
			separator = False
			optional = 0
			params = completion.params
			for param in params:
				name = param.description
				if len(name) == 0:
					continue
				search = name.find(" =")
				ellipsis = False
				if search != -1:
					name = name[:search]
					if separator:
						insertion += " [, "
					else:
						insertion += "[ "
					optional += 1
				elif name == "...":
					ellipsis = True
					if separator:
						insertion += ", "
				elif separator:
					insertion += "#>, "
				if optional == 0 and separator and ellipsis == False:
					insertion += "<#"
				if separator == False:
					separator = True
				insertion += name
			if optional > 0:
				insertion += " "
			for x in range(0, optional):
				insertion += "]"
			if separator:
				insertion = "<#"+insertion+"#>"
			if separator or kind == "function":
				item["insertion"] = "("+insertion+")"
				kind = "function"
		except AttributeError:
			pass
	item["kind"] = kind
	output.append(item)
print json.dumps(output)